<?php
/*************************************************************
* Joomla LinkExchange
* Author: Murz. Web-site http://devel.shtrix.ru
* Version 3.0.1
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
*************************************************************/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

// ensure user has access to this function
if (!($acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'all' )
                | $acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'com_linkexchange' ))) {
        mosRedirect( 'index2.php', _NOT_AUTH );
}

require_once( $mainframe->getPath( 'admin_html' ) );
require_once( $mainframe->getPath( 'class' ) );
require_once( 'config.linkexchange.php' );

$cid         = mosGetParam( $_POST, 'cid', array(0) );
$id         = mosGetParam( $_GET, 'id', 0 );

switch ($task) {
        case 'new':
                editLink( $option, 0 );
                break;

        case 'edit':
                editLink( $option, $cid[0] );
                break;

        case 'editA':
                editLink( $option, $id );
                break;

        case 'save':
                saveLink( $option );
                break;

        case 'remove':
                removeLinks( $cid, $option );
                break;

        case 'publish':
                publishLinks( $cid, 1, $option );
                break;

        case 'unpublish':
                publishLinks( $cid, 0, $option );
                break;

        case 'approve':
                break;

        case 'cancel':
                cancelLink( $option );
                break;

        case 'orderup':
                orderLinks( $cid[0], -1, $option );
                break;

        case 'orderdown':
                orderLinks( $cid[0], 1, $option );
                break;

        case 'check':
                checkLinks( $cid, $option );
                break;

        case 'ranks':
                showLinks( $option , 'Ranks' );
                break;

        default:
                showLinks( $option );
                break;
}

/**
* Compiles a list of records
* @param database A database connector object
*/
function showLinks( $option, $action=NULL) {
        global $database, $mainframe, $mosConfig_list_limit;

        $catid                 = $mainframe->getUserStateFromRequest( "catid{$option}", 'catid', 0 );
        $limit                 = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit );
        $limitstart = $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 );
        $search         = $mainframe->getUserStateFromRequest( "search{$option}", 'search', '' );
        $search         = $database->getEscaped( trim( strtolower( $search ) ) );

        $where = array();
        if ($catid > 0) {
                $where[] = "a.catid = $catid";
        }
        if ($search) {
                $where[] = "LOWER(a.title) LIKE '%$search%'";
        }

        // get the total number of records
        $query = "SELECT COUNT(*)"
        . "\n FROM #__linkexchange AS a"
        . (count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "")
        ;
        $database->setQuery( $query );
        $total = $database->loadResult();

        require_once( $GLOBALS['mosConfig_absolute_path'] . '/administrator/includes/pageNavigation.php' );
        $pageNav = new mosPageNav( $total, $limitstart, $limit  );

        $query = "SELECT a.*, cc.name AS category, u.name AS editor"
        . "\n FROM #__linkexchange AS a"
        . "\n LEFT JOIN #__categories AS cc ON cc.id = a.catid"
        . "\n LEFT JOIN #__users AS u ON u.id = a.checked_out"
        . ( count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "")
        . "\n ORDER BY a.catid, a.ordering"
        . "\n LIMIT $pageNav->limitstart, $pageNav->limit"
        ;
        $database->setQuery( $query );

        $rows = $database->loadObjectList();
        if ($database->getErrorNum()) {
                echo $database->stderr();
                return false;
        }

        // build list of categories
        $javascript         = 'onchange="document.adminForm.submit();"';
        $lists['catid'] = mosAdminMenus::ComponentCategory( 'catid', $option, intval( $catid ), $javascript );
        switch($action)
        {
            case('Ranks'):
                HTML_linkexchange::showRanks( $option, $rows, $lists, $search, $pageNav );
                break;
            default:
                HTML_linkexchange::showLinks( $option, $rows, $lists, $search, $pageNav );
                break;
        }
}

/**
* Compiles information to add or edit
* @param integer The unique id of the record to edit (0 if new)
*/
function editLink( $option, $id ) {
        global $database, $my, $mosConfig_absolute_path, $mosConfig_live_site;

        $lists = array();

        $row = new mosLinkExchange( $database );
        // load the row from the db table
        $row->load( $id );

        // fail if checked out not by 'me'
        if ($row->isCheckedOut( $my->id )) {
                mosRedirect( 'index2.php?option='. $option, 'The module $row->title is currently being edited by another administrator.' );
        }

        if ($id) {
                $row->checkout( $my->id );
        } else {
                // initialise new record
                $row->published = 1;
                $row->approved         = 1;
                $row->order         = 0;
                $row->catid         = mosGetParam( $_POST, 'catid', 0 );
        }

        // build the html select list for ordering
        $query = "SELECT ordering AS value, title AS text"
        . "\n FROM #__linkexchange"
        . "\n WHERE catid = $row->catid"
        . "\n ORDER BY ordering"
        ;
        $lists['ordering']                         = mosAdminMenus::SpecificOrdering( $row, $id, $query, 1 );

        // build list of categories
        $lists['catid']                         = mosAdminMenus::ComponentCategory( 'catid', $option, intval( $row->catid ) );
        // build the html select list
        $lists['published']                 = mosHTML::yesnoRadioList( 'published', 'class="inputbox"', $row->published );

        $file         = $mosConfig_absolute_path .'/administrator/components/com_linkexchange/linkexchange_item.xml';
        $params = new mosParameters( $row->params, $file, 'component' );

        HTML_linkexchange::editLink( $row, $lists, $params, $option );
}

/**
* Saves the record on an edit form submit
* @param database A database connector object
*/
function saveLink( $option ) {
        global $database, $my;

        $row = new mosLinkExchange( $database );
        if (!$row->bind( $_POST )) {
                echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
                exit();
        }
        // save params
        $params = mosGetParam( $_POST, 'params', '' );
        if (is_array( $params )) {
                $txt = array();
                foreach ( $params as $k=>$v) {
                        $txt[] = "$k=$v";
                }
                $row->params = implode( "\n", $txt );
        }

        $row->date = date( 'Y-m-d H:i:s' );
        if (!$row->check()) {
                echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
                exit();
        }
        if (!$row->store()) {
                echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
                exit();
        }

        if(!$row->ordering) {
            $query = "SELECT MAX(ordering)"
            . "\n FROM #__linkexchange "
            . "\n WHERE catid=".$row->catid
            ;
            $database->setQuery( $query );
            $max = $database->loadResult();
            $row->ordering=$max+1;
        }

        $row->checkin();
        $row->updateOrder( "catid = $row->catid" );
        mosRedirect( "index2.php?option=$option" );
}

/**
* Deletes one or more records
* @param array An array of unique category id numbers
* @param string The current url option
*/
function removeLinks( $cid, $option ) {
        global $database;

        if (!is_array( $cid ) || count( $cid ) < 1) {
                echo "<script> alert('Select an item to delete'); window.history.go(-1);</script>\n";
                exit;
        }
        if (count( $cid )) {
                $cids = implode( ',', $cid );
                $query = "DELETE FROM #__linkexchange"
                . "\n WHERE id IN ( $cids )"
                ;
                $database->setQuery( $query );
                if (!$database->query()) {
                        echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
                }
        }

        mosRedirect( "index2.php?option=$option" );
}

/**
* Publishes or Unpublishes one or more records
* @param array An array of unique category id numbers
* @param integer 0 if unpublishing, 1 if publishing
* @param string The current url option
*/
function publishLinks( $cid=null, $publish=1,  $option ) {
        global $database, $my;

        $catid = mosGetParam( $_POST, 'catid', array(0) );

        if (!is_array( $cid ) || count( $cid ) < 1) {
                $action = $publish ? 'publish' : 'unpublish';
                echo "<script> alert('Select an item to $action'); window.history.go(-1);</script>\n";
                exit;
        }

        $cids = implode( ',', $cid );

        $query = "UPDATE #__linkexchange"
        . "\n SET published = " . intval( $publish )
        . "\n WHERE id IN ( $cids )"
        . "\n AND ( checked_out = 0 OR ( checked_out = $my->id ) )"
        ;
        $database->setQuery( $query );
        if (!$database->query()) {
                echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
                exit();
        }

        if (count( $cid ) == 1) {
                $row = new mosLinkExchange( $database );
                $row->checkin( $cid[0] );
        }
        mosRedirect( "index2.php?option=$option" );
}
/**
* Moves the order of a record
* @param integer The increment to reorder by
*/
function orderLinks( $uid, $inc, $option ) {
        global $database;
        $row = new mosLinkExchange( $database );
        $row->load( $uid );
        $row->move( $inc, "published >= 0" );

        mosRedirect( "index2.php?option=$option" );
}

/**
* Cancels an edit operation
* @param string The current url option
*/
function cancelLink( $option ) {
        global $database;
        $row = new mosLinkExchange( $database );
        $row->bind( $_POST );
        $row->checkin();
        mosRedirect( "index2.php?option=$option" );
}


function checkLinks( $cid, $option ) {
        global $database, $leConfig;

        if (!is_array( $cid ) || count( $cid ) < 1) {
                echo "<script> alert('Select an item to check'); window.history.go(-1);</script>\n";
                exit;
        }
        if (count( $cid )) {
                $cids = implode( ',', $cid );
                $query = "SELECT * FROM #__linkexchange"
                . "\n WHERE id IN ( $cids )"
                ;
                $database->setQuery( $query );
                $rows=$database->loadObjectList();

                for ($i=0, $n=count( $rows ); $i < $n; $i++) {
                    $row = &$rows[$i];
  //                  $exist = backlinkCheck($row->backurl,$leConfig['siteurl'])? 1 : -1;

//                    echo "<pre><h1>".$row->url."</h1>";
                    $links=getLinks($row->backurl);
                    if($links==-1) {
                        $backlinks=-2;
                        $links_onpage=0;
                    }
                    else
                    {
                        $links_onpage=count($links);
                        $backlinks=0;
                        foreach($links as $link)
                        {
                         if(strstr(getDomain($link),$leConfig['exchangeUrl'])) $backlinks++;
                        }
                        if($backlinks==0)$backlinks=-1;
                    }
                    if($row->backlinks!=$backlinks || $row->links_onpage!=$links_onpage)
                    {
                        $row->backlinks=$backlinks;
                        $row->links_onpage=$links_onpage;
                        $query="UPDATE #__linkexchange SET backlinks='$backlinks', links_onpage='$links_onpage' WHERE id=".$row->id;

                        $database->setQuery( $query );
                        if (!$database->query()) {
                            echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
                        }

                    }


//                    $row->state=$exist;

// Google tools

/*                    include_once ('include/google.php');

                    $linkedpages = linkcheck($row->url,'google');
                    $indexedpages = GoogleLinks($row->url);

                    $pr[$i] = GooglePageRank($row->url);
                    $indexed[$i] = $indexedpages[google][0];
                    $links[$i] = $linkedpages[google][0];
*/
// Yandex
//                    include_once ('include/yandex.php');

//                    $cy[i]=getCY_url($row->url);

//                    echo "<b>$row->url</b>: PR $pr[$i], CY $cy[i], indexed $indexed[$i], links $links[$i] <br>";

                }
                HTML_linkexchange::showCheckResults( $rows, $option );
        }

//        mosRedirect( "index2.php?option=$option" );
}


function getLinks($url) {

    if(strlen($url)<5)return -1;
    if(!strstr($url,"http:"))$url="http://".$url;
    if(!$page=@file_get_contents($url)) { /* echo "Error openinig URL $url<br>"; */ return -1;}
    $n=preg_match_all("/<\s*a[^>]*>/is",$page,$arr);
//    echo "<pre>"; print_r($arr[0]);
    foreach($arr[0] as $a)
    {
        preg_match_all('/(?<=href=)(?:(?:[\'][^\']+[\'])|(?:["][^"]+["]))/ix',preg_replace('/(\s*=\s*)/ix','=',$a),$href);
        $urls[]=$href[0][0];
    }

    return $urls;
}

function getDomain($url) {
    $url=preg_replace("#[^\/: \.\w]#","",$url);
    preg_match("/^(http:\/\/)?([^\/]+)/i",  trim($url), $matches);
    return $matches[2];
}

function backlinkCheck($siteurl, $recip) {
   $text='';
   $arrText = @file($siteurl);
   for ($i=0; $i<count($arrText); $i++) {
      $text = $text . $arrText[$i];
   }

   if (eregi($recip, $text)) {
      return true; // set true if there is a backlink
   } else {
      return false; // set false if backlink is missing
   }
}


?>
