<?php
/*************************************************************
* Joomla LinkExchange
* Author: Murz. Web-site http://devel.shtrix.ru
* Version 3.0.0
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
*************************************************************/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

/**
* Category database table class
* @package Joomla
* @subpackage Weblinks
*/
class mosLinkExchange extends mosDBTable {
        /** @var int Primary key */
        var $id                                        = null;
        /** @var int */
        var $catid                                = null;
        /** @var int */
        var $sid                                = null;
        /** @var string */
        var $title                                = null;
        /** @var string */
        var $url                                = null;
        /** @var string */
        var $description                = null;
        /** @var datetime */
        var $date                                = null;
        /** @var int */
        var $hits                                = null;
        /** @var int */
        var $published                        = null;
        /** @var boolean */
        var $checked_out                = null;
        /** @var time */
        var $checked_out_time        = null;
        /** @var int */
        var $ordering                        = null;
        /** @var int */
        var $archived                        = null;
        /** @var int */
        var $approved                        = null;
        /** @var string */
        var $params                                = null;
        /** @var int */
        var $hits_in                                = null;
        /** @var string */
        var $button_text                           = null;
        /** @var string */
        var $backurl                               = null;
        /** @var string */
        var $button_img                               = null;
        /** @var string */
        var $button_code                               = null;
        /** @var int */
        var $state                                 = null;
        /** @var int */
        var $pr                                 = null;
        /** @var int */
        var $cy                                 = null;
        /** @var int */
        var $links_onpage                                 = null;
        /** @var int */
        var $indexed                                 = null;
        /** @var int */
        var $backlinks                                 = null;

        /**
        * @param database A database connector object
        */
        function mosLinkExchange( &$db ) {
                $this->mosDBTable( '#__linkexchange', 'id', $db );
        }
        /** overloaded check function */
        function check() {
                // filter malicious code
                $ignoreList = array( 'params' , 'button_code', 'description' );
                $this->filter( $ignoreList );

                // specific filters
                $iFilter = new InputFilter();

                if ($iFilter->badAttributeValue( array( 'href', $this->url ))) {
                        $this->_error = 'Please provide a valid URL';
                        return false;
                }

                /** check for valid name */
                if (trim( $this->title ) == '') {
                        $this->_error = _WEBLINK_TITLE;
                        return false;
                }
                /*
                if ( !( eregi( 'http://', $this->url ) || ( eregi( 'https://',$this->url ) )  || ( eregi( 'ftp://',$this->url ) ) ) ) {
                        $this->url = 'http://'.$this->url;
                }*/

                /** check for existing name */
                $query = "SELECT id"
                . "\n FROM #__weblinks "
                . "\n WHERE title = '$this->title'"
                . "\n AND catid = $this->catid"
                ;
                $this->_db->setQuery( $query );

                $xid = intval( $this->_db->loadResult() );
                if ($xid && $xid != intval( $this->id )) {
                        $this->_error = _WEBLINK_EXIST;
                        return false;
                }
//                $this->button_code=addslashes($this->button_code);
//                $this->description=addslashes($this->description);
                // Clearing URL from "http" and etc
                preg_match("/^(http:\/\/)?([^\/]+)/i",  trim($this->url), $matches);
                $this->url=$matches[2];

                return true;
        }
}
?>
